
#include "coordonnee.h"



//***************************************************************************
//classe de gestion pour le placement des objets : 
//				classe coordonnee
coordonnee::coordonnee(){
	x=0;
	y=0;
	vecteur_depl_x=0;
	vecteur_depl_y=0;//par defaut immobile
	tmp_depl_x=vecteur_depl_x;
	tmp_depl_y=vecteur_depl_y;
};


void coordonnee::init(int a,int b){
	x=a+DEPLACEMENT_X;
	y=b+DEPLACEMENT_Y;
	vecteur_depl_x=0;
	vecteur_depl_y=0;
	tmp_depl_x=0;
	tmp_depl_y=0;
};


void coordonnee::initX(int a){
	tmp_depl_x=a;
	if (tmp_depl_x<-5) tmp_depl_x=-5;
	if (tmp_depl_x>5) tmp_depl_x=5;
};

void coordonnee::initY(int a){
	tmp_depl_y=a;
	if (tmp_depl_y<-5) tmp_depl_y=-5;
	if (tmp_depl_y>5) tmp_depl_y=5;
};

void coordonnee::reduit(){
	if (vecteur_depl_x<0){
		vecteur_depl_x+=2;
		if (vecteur_depl_x>0)vecteur_depl_x=0;
	};
	if (vecteur_depl_x>0){
		vecteur_depl_x-=2;
		if (vecteur_depl_x<0)vecteur_depl_x=0;
	};
	if (vecteur_depl_y<0){
		vecteur_depl_y+=2;
		if (vecteur_depl_y>0)vecteur_depl_y=0;
	};
	if (vecteur_depl_y>0){
		vecteur_depl_y-=2;
		if (vecteur_depl_y<0)vecteur_depl_y=0;
	};
	tmp_depl_x=vecteur_depl_x;
	tmp_depl_y=vecteur_depl_y;
};

void coordonnee::deplace(){
	reduit();
	x+=vecteur_depl_x;
	y+=vecteur_depl_y;
	if (x<=DEPLACEMENT_X)x=DEPLACEMENT_X;
	if (x>=NB_CASE_X*50+DEPLACEMENT_X-32)x=NB_CASE_X*50+DEPLACEMENT_X-32;
	if (y<=DEPLACEMENT_Y-25)y=DEPLACEMENT_Y-25;
	if (y>=NB_CASE_Y*50+DEPLACEMENT_Y-58)y=NB_CASE_Y*50+DEPLACEMENT_Y-58;
	tmp_depl_x=vecteur_depl_x;
	tmp_depl_y=vecteur_depl_y;
};

void coordonnee::deplace(int direction){
	if (direction==0) this->deplace();
	else{
		switch (direction){
		case 1:vecteur_depl_y-=4;
			break;
		case 2:vecteur_depl_x+=4;
			break;
		case 3:vecteur_depl_x+=4;
			vecteur_depl_y-=4;
			break;
		case 4:vecteur_depl_y+=4;
			break;
		case 6:vecteur_depl_x+=4;
			vecteur_depl_y+=4;
			break;
		case 8:vecteur_depl_x-=4;
			break;
		case 9:vecteur_depl_x-=4;
			vecteur_depl_y-=4;
			break;
		case 12:vecteur_depl_x-=4;
			vecteur_depl_y+=4;
			break;
		};
	};
	reduit();
	if (vecteur_depl_x<-5) vecteur_depl_x=-5;
	if (vecteur_depl_x>5) vecteur_depl_x=5;
	if (vecteur_depl_y<-5) vecteur_depl_y=-5;
	if (vecteur_depl_y>5) vecteur_depl_y=5;
	tmp_depl_x=vecteur_depl_x;
	tmp_depl_y=vecteur_depl_y;
};

void coordonnee::actualise(){
	vecteur_depl_x=tmp_depl_x;
	vecteur_depl_y=tmp_depl_y;
	x+=vecteur_depl_x;
	y+=vecteur_depl_y;
	if (x<=DEPLACEMENT_X)x=DEPLACEMENT_X;
	if (x>=NB_CASE_X*50+DEPLACEMENT_X-32)x=NB_CASE_X*50+DEPLACEMENT_X-32;
	if (y<=DEPLACEMENT_Y-25)y=DEPLACEMENT_Y-25;
	if (y>=NB_CASE_Y*50+DEPLACEMENT_Y-58)y=NB_CASE_Y*50+DEPLACEMENT_Y-58;
};

coordonnee::coordonnee(coordonnee& c){
	this->vecteur_depl_x=c.vecteur_depl_x;
	this->vecteur_depl_y=c.vecteur_depl_y;
	this->x=c.x;
	this->y=c.y;
	tmp_depl_x=vecteur_depl_x;
	tmp_depl_y=vecteur_depl_y;
};
